# dx/dt=xy-x, dy/dt=y-xy+sin^2(wt)
# from t=0 to t=10 with w=1 and initial condition x=y=1 at t=0
import numpy as np
import matplotlib.pyplot as plt

def f(r, t):  # dr/dt
  x=r[0]
  y=r[1]
  fx=x*y-x
  fy=y-x*y+np.sin(t)**2
  return np.array([fx, fy], float)

if __name__=="__main__":
  t=np.linspace(0, 10, 1000)
  r=np.ones([len(t), 2])
  #x=np.ones_like(t)
  # y=np.ones_like(t)
  k=np.zeros([4, 2], float)   # Fourth Order Runge-Kutta Method
  h=t[1]-t[0]
  
  for i in range(1, len(t)):    # Vector calculation
    #r=[x[i-1], y[i-1]]
    k[0]=h*f(r[i-1], t[i-1])
    k[1]=h*f(r[i-1]+k[0]/2, t[i-1]+h/2)
    k[2]=h*f(r[i-1]+k[1]/2, t[i-1]+h/2)
    k[3]=h*f(r[i-1]+k[2], t[i-1]+h)
    r[i]=r[i-1]+(k[0]+2*k[1]+2*k[2]+k[3])/6
  
  plt.plot(t, r[:, 0])
  plt.plot(t, r[:, 1])
  plt.show()
